Loading...
Searching...
No Matches
Opm::Co2GasPvt< Scalar, Storage > Class Template Reference

This class represents the Pressure-Volume-Temperature relations of the gas phase for CO2. More...

`#include <Co2GasPvt.hpp>`

## Public Types

using | BinaryCoeffBrineCO2 = BinaryCoeff::Brine_CO2<Scalar, H2O, CO2>
| The binary coefficients for brine and CO2 used by this fluid system.

## Public Member Functions

| Co2GasPvt (const ContainerT &salinity, int activityModel=3, int thermalMixingModel=1, Scalar T_ref=288.71, Scalar P_ref=101325)
| Co2GasPvt (const Params &params, const ContainerT &brineReferenceDensity, const ContainerT &gasReferenceDensity, const ContainerT &salinity, bool enableEzrokhiDensity, bool enableVaporization, int activityModel, Co2StoreConfig::GasMixingType gastype)
void | setNumRegions (std::size_t numRegions)
OPM_HOST_DEVICE void | setVapPars (const Scalar, const Scalar)
OPM_HOST_DEVICE void | setReferenceDensities (unsigned regionIdx, Scalar rhoRefBrine, Scalar rhoRefGas, Scalar)
| Initialize the reference densities of all fluids for a given PVT region.
OPM_HOST_DEVICE void | setEnableVaporizationWater (bool yesno)
| Specify whether the PVT model should consider that the water component can vaporize in the gas phase.
OPM_HOST_DEVICE void | setActivityModelSalt (int activityModel)
| Set activity coefficient model for salt in solubility model.
OPM_HOST_DEVICE void | setThermalMixingModel (int thermalMixingModel)
| Set thermal mixing model for co2 in brine.
OPM_HOST_DEVICE void | initEnd ()
| Finish initializing the co2 phase PVT properties.
OPM_HOST_DEVICE unsigned | numRegions () const
| Return the number of PVT regions which are considered by this PVT-object.
OPM_HOST_DEVICE Scalar | hVap (unsigned) const
template<class Evaluation>
OPM_HOST_DEVICE Evaluation | internalEnergy (unsigned regionIdx, const Evaluation &temperature, const Evaluation &pressure, const Evaluation &rv, const Evaluation &rvw) const
| Returns the specific enthalpy [J/kg] of gas given a set of parameters.
template<class Evaluation>
OPM_HOST_DEVICE Evaluation | viscosity (unsigned regionIdx, const Evaluation &temperature, const Evaluation &pressure, const Evaluation &, const Evaluation &) const
| Returns the dynamic viscosity [Pa s] of the fluid phase given a set of parameters.
template<class Evaluation>
OPM_HOST_DEVICE Evaluation | saturatedViscosity (unsigned, const Evaluation &temperature, const Evaluation &pressure) const
| Returns the dynamic viscosity [Pa s] of fluid phase at saturated conditions.
template<class Evaluation>
OPM_HOST_DEVICE Evaluation | inverseFormationVolumeFactor (unsigned regionIdx, const Evaluation &temperature, const Evaluation &pressure, const Evaluation &rv, const Evaluation &rvw) const
| Returns the formation volume factor [-] of the fluid phase.
template<class FluidState, class LhsEval = typename FluidState::Scalar>
std::pair< LhsEval, LhsEval > | inverseFormationVolumeFactorAndViscosity (const FluidState &fluidState, unsigned regionIdx)
| Returns the formation volume factor [-] and viscosity [Pa s] of the fluid phase.
template<class Evaluation>
OPM_HOST_DEVICE Evaluation | saturatedInverseFormationVolumeFactor (unsigned regionIdx, const Evaluation &temperature, const Evaluation &pressure) const
| Returns the formation volume factor [-] of water saturated gas at given pressure.
template<class Evaluation>
OPM_HOST_DEVICE Evaluation | saturationPressure (unsigned, const Evaluation &, const Evaluation &) const
| Returns the saturation pressure of the gas phase [Pa] depending on its mass fraction of the brine component.
template<class Evaluation>
OPM_HOST_DEVICE Evaluation | saturatedWaterVaporizationFactor (unsigned regionIdx, const Evaluation &temperature, const Evaluation &pressure) const
| Returns the water vaporization factor [m^3/m^3] of the water phase.
template<class Evaluation = Scalar>
OPM_HOST_DEVICE Evaluation | saturatedWaterVaporizationFactor (unsigned regionIdx, const Evaluation &temperature, const Evaluation &pressure, const Evaluation &saltConcentration) const
| Returns the water vaporization factor [m^3/m^3] of water phase.
template<class Evaluation>
OPM_HOST_DEVICE Evaluation | saturatedOilVaporizationFactor (unsigned regionIdx, const Evaluation &temperature, const Evaluation &pressure, const Evaluation &, const Evaluation &) const
| Returns the oil vaporization factor [m^3/m^3] of the oil phase.
template<class Evaluation>
OPM_HOST_DEVICE Evaluation | saturatedOilVaporizationFactor (unsigned regionIdx, const Evaluation &temperature, const Evaluation &pressure) const
| Returns the oil vaporization factor [m^3/m^3] of the oil phase.
template<class Evaluation>
OPM_HOST_DEVICE Evaluation | diffusionCoefficient (const Evaluation &temperature, const Evaluation &pressure, unsigned) const
OPM_HOST_DEVICE Scalar | gasReferenceDensity (unsigned regionIdx) const
OPM_HOST_DEVICE Scalar | oilReferenceDensity (unsigned regionIdx) const
OPM_HOST_DEVICE Scalar | waterReferenceDensity (unsigned regionIdx) const
OPM_HOST_DEVICE Scalar | salinity (unsigned regionIdx) const
void | setEzrokhiDenCoeff (const std::vector< EzrokhiTable > &denaqa)
OPM_HOST_DEVICE const ContainerT & | getBrineReferenceDensity () const
OPM_HOST_DEVICE const ContainerT & | getGasReferenceDensity () const
OPM_HOST_DEVICE const ContainerT & | getSalinity () const
OPM_HOST_DEVICE bool | getEnableEzrokhiDensity () const
OPM_HOST_DEVICE bool | getEnableVaporization () const
OPM_HOST_DEVICE int | getActivityModel () const
OPM_HOST_DEVICE Co2StoreConfig::GasMixingType | getGasType () const
OPM_HOST_DEVICE const Params & | getParams () const

## Static Public Member Functions

static OPM_HOST_DEVICE constexpr bool | isActive ()

## Detailed Description

template<class Scalar, template< class > class Storage = VectorWithDefaultAllocator>
class Opm::Co2GasPvt< Scalar, Storage >

This class represents the Pressure-Volume-Temperature relations of the gas phase for CO2.

## Member Function Documentation

## saturationPressure()

template<class Scalar, template< class > class Storage = VectorWithDefaultAllocator>
template<class Evaluation>

OPM_HOST_DEVICE Evaluation Opm::Co2GasPvt< Scalar, Storage >::saturationPressure | ( | unsigned | ,
|  | const Evaluation & | ,
|  | const Evaluation & | ) const

inline

Returns the saturation pressure of the gas phase [Pa] depending on its mass fraction of the brine component.

Parameters

  Rvw | The surface volume of brine component vaporized in what will yield one cubic meter of water at the surface [-]

## setEnableVaporizationWater()

template<class Scalar, template< class > class Storage = VectorWithDefaultAllocator>

OPM_HOST_DEVICE void Opm::Co2GasPvt< Scalar, Storage >::setEnableVaporizationWater | ( | bool | yesno | ) |

inline

Specify whether the PVT model should consider that the water component can vaporize in the gas phase.

By default, vaporized water is considered.

The documentation for this class was generated from the following files:

- opm/material/fluidsystems/blackoilpvt/Co2GasPvt.hpp
- opm/material/fluidsystems/blackoilpvt/Co2GasPvt.cpp